	    title	Dummy DEBUG lookalike segment for Windows profile code.
	    .286c
	    include	macros.m

DEBUG_TEXT	SEGMENT	 PARA
DEBUG_TEXT	ENDS
_TEXT	SEGMENT	 BYTE PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT	 WORD PUBLIC 'DATA'
_DATA	ENDS
XIB	SEGMENT  WORD PUBLIC 'DATA'
XIB	ENDS
XI	SEGMENT  WORD PUBLIC 'DATA'
XI	ENDS
XIE	SEGMENT  WORD PUBLIC 'DATA'
XIE	ENDS
XCB	SEGMENT  WORD PUBLIC 'DATA'
XCB	ENDS
XC	SEGMENT  WORD PUBLIC 'DATA'
XC	ENDS
XCE	SEGMENT  WORD PUBLIC 'DATA'
XCE	ENDS
CONST	SEGMENT	 WORD PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT	 WORD PUBLIC 'BSS'
_BSS	ENDS
DGROUP	GROUP	CONST,	_BSS, XC, XI, _DATA
	ASSUME	CS: _TEXT, DS: DGROUP, SS: DGROUP, ES: DGROUP

_TEXT	SEGMENT	 BYTE PUBLIC 'CODE'
	EXTRN	_DebugProc:FAR,_TimerProc:FAR,_MultiPlex:FAR,_ClearSegments:FAR
_TEXT	ENDS
; The debug_text segment contains some code to look like SYMDEB. It must be linked into
; the breakpoint vector at 0:4 to be visible to windows.
; The requirements therefore are:
;	Call InitDebugSeg before running windows.
;	Call ClearDebugSeg at end of program.
;	Make sure that there is a valid handler for the debug code routine.
DEBUG_TEXT	SEGMENT
		ASSUME CS:DEBUG_TEXT
		EVEN
OldInt3Vector	DD	0
OldTimerVector	DD	0
Old_MultiPlex	DD	0
MULTIPLEXINT	equ	2fh
TIMERINTNO	equ	70h
TIMERINTERVAL	DW	100	; I want 10 interrupts per second
TimerDelay	DW	100	; Milliseconds between interrupts
EntryLock	DB	0
DISABLETIMER	equ	80h
TIMEROFF	equ	40h	; User flag to disable timer
LOCKTIMER	equ	01h
USERLOCK	equ	40h

Int3Handler	PROC	FAR
		jmp	dword ptr cs:OldInt3Vector
Int3Handler	ENDP

DebugProcEntry	PROC	FAR
		cli
		enter	0,0
		or	EntryLock,DISABLETIMER
		sti
		push	ds
		mov	ax,SEG DGROUP
		mov	ds,ax
		lea	ax,ss:[bp+8]	; Point to args
		push	ss
		push	ax
		push	[bp+6]
		call	far ptr _DebugProc
		add	sp,6
		cli
		and	EntryLock,NOT DISABLETIMER
		pop	ds
		leave
		sti
		ret
DebugProcEntry	ENDP

TimerHandler	PROC	FAR
;
; This is the timer tick routine
		pusha
		mov	al,LOCKTIMER
		xchg	al,cs:EntryLock
		or	al,al
		.IF z
		   sub	cs:TimerDelay,1
		   .IF le
		      sti
		      push	es
		      push	ds
		      cld		; Needed for C environment
		      mov	al,20h
		      out	20h,al
		      mov	ax,SEG DGROUP
		      mov  ds,ax
		      call	_TimerProc
		      pop	ds
		      assume	ds:NOTHING
		      pop	es
		      mov	ax,cs:TIMERINTERVAL
		      mov cs:TimerDelay,ax
		   .FI
		   mov	cs:EntryLock,0
		.ELSE
		   mov	cs:EntryLock,al
		.FI
		popa
		jmp dword ptr OldTimerVector
TimerHandler	ENDP
		ORG	0fbh
		jmp	DebugProcEntry

		ORG	0100h
		DB	'SEGDEBUG',0

;
; DOS Multiplex interrupt is used to control profiling.
; The following functions are supported:
;
;	AX = DB00	- Check already loaded. Returns al=0xff if already here.
;	AX = DB80	- Turn off profiling
;	AX = DB81	- Turn on profiling
;	AX = DB82	- Clear stats
;	AX = DB83	- Collect stats returns DS:DX pointing to data.
; Possible future enhancements: Add a call to write the stats to a given file handle. This would allow a
; program to collect partial results about itself.
; I could also try to produce a clipboard format for stats.
;
MultiPlexEntry	PROC	FAR
            cmp         ah,0DBh
	    .IF ne
	       jmp Old_MultiPlex
	    .FI
            or          al,al
            .IF e
               mov	al,0ffh                 ; Already loaded.
	       iret
	    .FI

	    cmp		al,80h		; Turn off
	    .IF e
	       or	EntryLock,TIMEROFF
	    .ELSE
	       cmp al,81h
	       .IF z
	          and	EntryLock,NOT TIMEROFF
               .ELSE
	          cmp al,82h
	          .IF z
		     push	ds
		     mov	ax,SEG DGROUP
		     mov	ds,ax
		     call	_ClearSegments
		     pop	ds
		  .ELSE
		     cmp al,83h
		     .IF z
		     .FI
		  .FI
	       .FI
	    .FI
            iret                    ; Or jump to old owner of interrupt
MultiPlexEntry	ENDP

DEBUG_TEXT	ENDS

_DATA	SEGMENT
DummyEvent	DD	0
_DATA	ENDS

; This is small memory model only. For medium/large models the
; init and term routines must be far procs.
; Setup is currently manual (call init and clear procs). When the rest of this works,
; I shall probably change it to use auto setup as for criterr.
_TEXT	SEGMENT
		ASSUME	CS:_TEXT
	PUBLIC  _InitDebugSeg, _ClearDebugSeg, _OutCh, _LockTimer
_InitDebugSeg	PROC	NEAR
		enter 0,0
		mov	bx,ss:[bp+4]	; Timer period in milliseconds
		push	ds
		mov	ax,SEG DEBUG_TEXT
		mov	ds,ax
		assume	ds:DEBUG_TEXT
		mov	word ptr TIMERINTERVAL,bx
		mov	word ptr TimerDelay,bx

		mov	ax,3503h	; Get breakpoint vector
		int	21h
		mov	word ptr OldInt3Vector,bx
		mov	word ptr OldInt3Vector+2,es
		mov	dx,OFFSET DEBUG_TEXT:Int3Handler
		mov	ax,2503h	; Set it to mine
		int	21h

		mov	ax,3500h + TIMERINTNO
		int	21h
		mov	word ptr OldTimerVector,bx
		mov	word ptr OldTimerVector+2,es
		mov	dx,OFFSET DEBUG_TEXT:TimerHandler
		mov	ax,2500h + TIMERINTNO	; Set it to mine
		int	21h

		mov	ax,3500h + MULTIPLEXINT
		int	21h
		mov	word ptr Old_MultiPlex,bx
		mov	word ptr Old_MultiPlex+2,es
		mov	dx,OFFSET DEBUG_TEXT:MultiPlexEntry
		mov	ax,2500h + MULTIPLEXINT	; Set it to mine
		int	21h

		pop	ds
		assume	ds:DGROUP
;
; Start the event timer to ensure a source of interrupts...
		mov	ax,8300h	; Set event timer
		push	ds
		pop	es
		mov	bx,OFFSET DGROUP:DummyEvent
		mov	cx,-1
		mov	dx,-1
		int	15h
		leave
		ret
_InitDebugSeg	ENDP

_ClearDebugSeg	PROC	NEAR
		push	ds
		mov	ax,SEG DEBUG_TEXT
		mov	es,ax
		assume	es:DEBUG_TEXT

		lds	dx,OldInt3Vector
		mov	ax,2503h	; Reset the vector
		int	21h

		lds	dx,OldTimerVector
		mov	ax,2500h + TIMERINTNO	; Reset the vector
		int	21h

		lds	dx,Old_MultiPlex
		mov	ax,2500h + MULTIPLEXINT	; Reset the vector
		int	21h

		mov	ax,8301h	; Cancel event timer
		push	ds
		pop	es
		mov	bx,OFFSET DGROUP:DummyEvent
		mov	cx,-1
		mov	dx,-1
		int	15h
		pop	ds
		ret
_ClearDebugSeg	ENDP

_OutCh	PROC		; Put character to serial port - bypass DOS
	pop	bx	; Return address
	pop	ax	; al = character
	push	ax
	mov	ah,1
	mov	dx,0
	int	14h
	jmp	bx
_OutCh	ENDP

_LockTimer	PROC
	pop	bx
	pop	ax	; Flag TRUE to lock timer, FALSE to unlock it.
	push	ax
	mov	cx,seg DEBUG_TEXT
	mov	es,cx
	assume	es:DEBUG_TEXT
	or	ax,ax
	.IF z
	   and  es:EntryLock,NOT USERLOCK
	.ELSE
	   or   es:EntryLock,USERLOCK
	.FI
	jmp	bx
_LockTimer	ENDP
_TEXT	ENDS
	END
