typedef void (far *FARPROC)();
typedef unsigned int WORD;
typedef char far *LPSTR;
typedef WORD BOOL;
typedef unsigned char BYTE;
typedef char *PSTR;

typedef struct NSTR {
   BYTE len;
   char s[1];
} NSTR;		/* A string with leading length byte - used in SYM files */

typedef struct SYMHDR {
   WORD ParaLen;
   WORD xxx1;
   WORD EntrySeg;
   WORD Nconsts;
   WORD OffLUT;
   WORD Nsegs;
   WORD FirstSeg;
   BYTE xxx2;
/*   NSTR ModuleName;*/
} SYMHDR;

typedef struct SYMSEG {
   WORD ParaNext;
   WORD Nsyms;
   WORD OffLUT;
   WORD Ordinal;
   WORD Rsrv[4];
   WORD LineNumbers;
   WORD xxx3;
/*   NSTR SegName;*/
} SYMSEG;

typedef struct SYMBOL {
   WORD value;
   NSTR Name;
} SYMBOL;

typedef SYMHDR *PSYMHDR;
typedef SYMSEG *PSYMSEG;
typedef SYMBOL *PSYMBOL;
typedef NSTR *PNSTR;

/*
 * The following data structure gives the arguments for various forms of the debugging procs.
 * N.B. SS != DS while in DebugProc.
 */
typedef union ARG {
   WORD pGlobalHeap;
   WORD DiscardSeg;
   struct MOVE {
      WORD from;
      WORD to;
   } m;
   struct DEFINE {
      LPSTR SegName;
      WORD Ordinal;
      WORD SegLoc;
      WORD Instance;
      WORD Type;
   } d;
} ARG;

typedef struct MODULENAME *PMODULE;
typedef struct SEGMENT *PSEGMENT;
typedef struct PD *PPD;

typedef struct MODULENAME {
   PSEGMENT pseg;
   char name[9];
} MODULENAME;

typedef struct SEGMENT {
   PSEGMENT next;
   WORD ordinal, instance, type;
   PMODULE module;
   WORD location;
   PPD Procs;
   WORD hitcount;
} SEGMENT;

typedef struct VALBLOCK {
   WORD label;
   WORD count;
} VALBLOCK;

typedef struct PD {
   PSTR filename;
   PNSTR segname;
   WORD miss;
   WORD len;
   VALBLOCK vals[1];
} PD;

